#!/usr/bin/env python3

from __future__ import print_function

usage = """Usage:
python3 example-service.py &
python3 example-client.py
python3 example-client.py --exit-service
"""

# nfs cloud account sync
# this is dbus client demo

import sys
from traceback import print_exc

import dbus

def main():
    # bus = dbus.SessionBus()
    bus = dbus.SystemBus()
    try:
        remote_object = bus.get_object("com.nfs.cloud.sync.AccountService",
                                       "/Objects")

        # you can either specify the dbus_interface in each call...
        hello_reply_list = remote_object.GetUserInfo("nfs",
            dbus_interface = "com.nfs.cloud.sync.AccountInterface")
    except dbus.DBusException:
        print_exc()
        print(usage)
        sys.exit(1)

    print("hello_reply_list client:", hello_reply_list)

    # ... or create an Interface wrapper for the remote object
    iface = dbus.Interface(remote_object, "com.nfs.cloud.sync.AccountInterface")
   
 
    if sys.argv[1:] == ['--exit-service']:
        iface.Exit()

if __name__ == '__main__':
    main()