import getpass
import os
import pwd
import json

def setUserConfigJson(username,jsonStr):
    configJson = "/home/"+username+"/.caccount/config/user-desktop.json"
    f = open(configJson,'w')
    f.write(jsonStr)
    f.close()

def getUserConfigJson(username):
    configJson = "/home/"+username+"/.caccount/config/user-desktop.json"
    if os.path.isfile(configJson):
        configJsonFile = open(configJson, 'r')
        configStr = configJsonFile.read()
        # logger.debug(configStr)
        configJsonFile.close()
        return json.loads(configStr)
    else:
        return {}
# 从用户文件获取配置开关项 是否同步 ，同步哪些项
def getConfigJson(username):
    configJson = "/home/"+username+"/.caccount/config/config.json"
    if os.path.isfile(configJson):
        configJsonFile = open(configJson, 'r')
        configStr = configJsonFile.read()
        # logger.debug(configStr)
        configJsonFile.close()
        # {"desktop":2,"font":2,"issyn":2,"mouse":2,"network":2,"power":2,"screen":0,"taskbar":2,"theme":2}
        return json.loads(configStr)
    else:
        # logger.debug('can not found config file for user: '+username)
        return {"desktop":0,"font":0,"issyn":0,"mouse":0,"network":0,"power":0,"screen":0,"taskbar":0,"theme":0}

# wifi文件路径 list wifi files
def wifiPath(lpath, lfilelist):
    if os.path.exists(lpath) == False:
        print('network path is not exsit for'+lpath)
        return []
    list = os.listdir(lpath)
    for f in list:
        file = os.path.join(lpath, f)
        if is_chinese(file):
            continue
        if os.path.isdir(file):        
            wifiPath(file, lfilelist)
        else:
            lfilelist.append(file)
    return lfilelist
 
#检查整个字符串是否包含中文
def is_chinese(string):
    for ch in string:
        if u'\u4e00' <= ch <= u'\u9fff':
            return True

    return False


# 获取无线网卡设备名称
def getWifiDeviceName():
    wifiInterfaceName = ''
    re = os.popen('iwconfig ')
    deviceInterfaceStr = re.read()
    deviceInterfaceArr = deviceInterfaceStr.splitlines();
    for line in deviceInterfaceArr:
        strs = line.split(' ')
        temp = strs[0]
        if temp.startswith('wl'):
            wifiInterfaceName = temp.strip()
    return wifiInterfaceName


def getOsInfo():
    output = os.popen('cat /etc/os-release ')
    item_str = output.read()
    items = {}
    for line in item_str.splitlines():
        strs = line.split('=')
        if len(strs)<2:
            continue
        item_key = strs[0]
        item_val = strs[1]
        items[item_key]=item_val
        # items.append({'key':item_key,'val':item_val})
    return items

def getOsCodeName():
    osInfo = getOsInfo()
    if osInfo.get('VERSION_CODENAME'):
        return osInfo.get('VERSION_CODENAME')
    if osInfo.get('CODENAME'):
        return osInfo.get('CODENAME')
    
    return 'tiger'

def get_current_desktop_user():

    current_desktop_username = ''
    current_desktop_uid = 1000

    output = os.popen("  who | grep ':0' | awk -F ' '  '{print $1}'  ")
    current_desktop_username = output.read().strip()
    if current_desktop_username != '':
        current_desktop_uid = pwd.getpwnam(current_desktop_username).pw_uid

    return current_desktop_username,current_desktop_uid